Package: Rlab
Title: Functions and Datasets Required for ST370 Class
Version: 4.5.1
Date: 2026-02-10
Authors@R: c(person(given = c("Dennis", "D."),
                      family = "Boos",
                      role = "aut"),
               person(given = "Douglas",
                      family = "Nychka",
                      role = "aut"),
               person(given = "Dennis",
                      family = "Boos",
                      role = "cre",
                      email = "boos@ncsu.edu"))
Maintainer: Dennis Boos <boos@ncsu.edu>
Depends: R (>= 2.10), utils
Imports: stats
Description: Provides functions and datasets required for the ST 370 course at North Carolina State University.
License: GPL (>= 2)
URL: https://www.r-project.org,
        https://www4.stat.ncsu.edu/~bmasmith/NewST370WEB/rlab/rlab.html
Packaged: 2026-02-11 01:06:02 UTC; boos
Repository: CRAN
Date/Publication: 2026-02-11 06:11:05 UTC
NeedsCompilation: no
Author: Dennis D. Boos [aut],
  Douglas Nychka [aut],
  Dennis Boos [cre]
Built: R 4.6.0; ; 2026-04-25 17:09:53 UTC; unix

# Remove the previous line if you edit this file

# Export all names
exportPattern(".")

# Import all packages listed as Imports or Depends
import(utils,stats)
importFrom("graphics", "abline", "axis", "hist", "lines", "par",
             "points", "text", "title")

1/25/92:

	Rlab is _not_ a clone of languages such as those used by tools
	like MATLAB or matrix_X/Xmath. However, as Rlab focuses on
	creating a good experimental environment (or laboratory) in
	which to do matrix math, it can be called "MATLAB-like" since
	the programming language possesses similar operators and
	concepts.  Extensive use has been made of the LAPACK, FFTPACK
	and RANLIB sources available from netlib.

	The most significant difference between the other proprietary
	tools and RLaB is the GNU Copyleft.

	See the file README.install for installation instructions.

	Ian Searle
   	ians@eskimo.com

	examples/README:

	This directory contains various examples of RLaB usage. The
	examples are not intended to serve as anything other than
	syntax, and usage examples. Do not rely on the examples to
	provide correct answers, or appropriate algorithms.

	Test Matrices:

	The files in this directory are translations of the files in
	the testmatrix distribution available from netlib. The
	following is the original README file.

	Obviously all of the mfiles are not translated yet.

My paper ``A Collection of Test Matrices in MATLAB'' has been accepted for
publication in ACM Trans. Math. Soft., and in revising the paper I have
prepared a new version of the collection of M-files.  The version previously in
Netlib was `Version 1.1, November 15 1989' (as returned by the command
`matrix(-1)') and the new one is `Version 1.2, May 30 1990'.

Here is a summary of the changes in going from the original Version 1.0 of
July 4, 1989 to Version 1.2.   Those marked with a `*' were already (partially)
present at Version 1.1.

(1]  Some improvements to the documentation in the comment lines of the
M-files, including correction of errors, improved wording, and extra
references.

(2]  A few minor bugs or inefficiencies corrected.

(3]  Added a new matrix, bringing the total to 45:

%AUGMENT  AUGMENT(A) is the square matrix [EYE(m) A; A' ZEROS(n)] of dimension
%         m+n, where A is m-by-n.  It is the symmetric and indefinite
%         coefficient matrix of the augmented system associated with a least
%         squares problem minimize NORM(A*x-b).
%         Special case: if A is a scalar, n say, then AUGMENT(A) is the same
%                       as AUGMENT(RAND(p,q)) where n = p+q and p = ROUND(n/2),
%                       that is, a random augmented matrix of dimension n is
%                       produced.

(4]  Added an extra option to ORTHOG:

function Q = orthog(n, k)
%ORTHOG Orthogonal and nearly orthogonal matrices.
%       Q = ORTHOG(N, K) selects the K'th type of matrix of order N.
...
%       K = 4:  Helmert matrix: a permutation of a lower Hessenberg matrix,
%               whose first row is ONES(1:N)/SQRT(N).

(5]  Changed second parameter in SPARSE from a character selecting the plot
type to a tolerance such that elements smaller than the tolerance are
regarded as zero.

(6)  Added extra functionality to RANDSVD:

function A = randsvd(n, kappa, mode, kl, ku)
%RANDSVD  Random matrices with pre-assigned singular values.
...
%      Special case: if KAPPA < 0 then a random full symmetric positive
%                    definite matrix is produced with COND(A) = -KAPPA and
%                    eigenvalues distributed according to MODE.
%                    KL and KU, if present, are ignored.

(7)  Changed SEE.  It now works for rectangular matrices.  Instead of the
inverse, the pseudo-inverse is plotted in the second window.  The plot of
columns of A versus the row index in the third window is replaced in this
new version by a plot of the singular values of A on a logarithmic scale.

(8)  HOUSE now avoids division by zero when it is given a zero vector
(BANDRED is the only routine that calls HOUSE).


---Nick Higham
   Dept. of Mathematics
   University of Manchester
   na.nhigham@na-net.stanford.edu
   October 10, 1990

//FILTER Digital filter.
//       Y = FILTER(B, A, X) filters the data in vector X with the
//       filter described by vectors A and B to create the filtered
//       data Y.  The filter is a "Direct Form II Transposed"
//       implementation of the standard difference equation:
//
//       a(1)*y(n) = b(1)*x(n) + b(2)*x(n-1) + ... + b(nb+1)*x(n-nb)
//                        - a(2)*y(n-1) - ... - a(na+1)*y(n-na)

// dependencies

rfile is
rfile fliplr

filter = function(a_,b_,x_) {
  local(y,M,N,outlength,ix,a,b,x,column)

  a = a_; b = b_; x = x_;
  if (!isvector(b) || !isvector(a) || !isvector(x)) {
    error("filter: Inputs must be vectors");
  }

  M = length(a); N = length(b);
  // Output may be infinite length (could be IIR) so we arbitrarily decide that
  // the output will have the same length as the input x.
  outlength = length(x);
  
  if (M < outlength) {  // Pad a if necessary
    a[outlength] = 0;
  }
  if (N < outlength) {  // Pad b if necessary
    b[outlength] = 0;
  }
  if (length(x) < outlength) { // Pad x if necessary
    x[outlength] = 0;
  }

  // We want the output to have the same shape as the input (row for row input
  // and column for column input). However, for easier processing, we force
  // data to be column vectors and coefficients to be row vectors. Then, we
  // we have to flip a,b since we're really doing a convolution.
  y = zeros(outlength,1);
  a = reshape(a,1,length(a)); a = fliplr(a);
  b = reshape(b,1,length(b)); b = fliplr(b);
  if (x.nr == 1) {
    column = 0;      // Indicate that output is a row vector
    x = x[:];
  else
    column = 1;      // Indicate that output is a column vector
  }

  y[1] = (a[outlength]/b[outlength])*x[1];
  if (outlength == 1) { return y; }

  for (ix in 2:outlength) {
    y[ix] = (-(b[outlength-ix+1:outlength-1]*y[1:ix-1]) + ...
             (a[outlength-ix+1:outlength]*x[1:ix])) / b[outlength];
  }

  if (column == 0) {
    y = reshape(y,1,length(y));
  }
  return y;
}

//-------------------------------------------------------------------//

//  Syntax:	clearall ( )

//  Description:

//  The function clearall, clears all data objects from the workspace.
//  Scalars, strings, matrices, and lists are cleared with the clear
//  function. User function are not affected by clearall. If you wish
//  to remove user functions you must do so explicitly with clear.
//

//  See Also: clear
//-------------------------------------------------------------------//


clearall = function ( )
{
  local (i);

  for (i in members ($$))
  {
    if (class ($$.[i]) != "built-in" && class ($$.[i]) != "user-function")
    {
      clear ($$.[i]);
    }
  }
};

//  polyval.r:
//  polyval(v, x)      Polynomial evaluation.
//  If v is a vector whose elements are the coefficients of a
//  polynomial, then polyval(v,x) is the value of the
//  polynomial evaluated at x.  If x is a vector,
//  the polynomial is evaluated at all points in x.
//

polyval = function (c, x) 
{
  local(i, m, nc, y);

  m = size(x);
  nc = max( size(c) );
  y = zeros(m);
  for(i in 1:nc) {
    y = x.*y + c[i]*ones(m);
  }

  return y;
};

//-------------------------------------------------------------------//
//
// 1st cut at sign function
// Return 1,  if element >= 0
// Return 0,  if element == 0
// Return -1, if element < 0
//
// Does not handle complex quantities like MATLAB
//

sign = function(a)
{
  local(i, j, r);
  
  if(type(a) == "complex") 
    {
      return a ./ abs(a);
    }

  if(class(a) == "scalar") 
    {
      if(a >  0) { return 1; }
      if(a == 0) { return 0; }
      if(a <  0) { return -1; }
    }

  r = zeros( size(a) );
  for(i in 1:size(a)[1]) 
    {
      for(j in 1:size(a)[2]) 
	{
	  if(a[i;j] >  0) { r[i;j] = 1; }
	  if(a[i;j] == 0) { r[i;j] = 0; }
	  if(a[i;j] <  0) { r[i;j] =-1; }
	}
    }

  return r;
};

// fftshift -- swap two halves of a vector or swap quadrants of a matrix

fftshift = function(M) {
  local(F,Top,Bot,Left,Right,N);

  if (class(M) != "matrix") {
    error("fftshift: A matrix argument is required");
  }

  // Assign the matrix to the result since if the height or width is odd,
  // one row or column will never be assigned.
  F = M;

  // If we have a vector, then it's easy.
  if (isvector(F)) {
    N = length(F);
    // Swap the right and left halves of the matrix.
    Left  = F[1:floor(N/2)];
    Right = F[ceil(N/2)+1:N];

    // Do the swap.
    F[1:floor(N/2)] = Right;
    F[ceil(N/2)+1:N] = Left;

    return F;
  }
    
  // Swap the top and bottom half of each column. First put the top
  // rows and bottom rows into separate matrices.
  Top = F[1:floor(F.nr/2);];
  Bot = F[ceil(F.nr/2)+1:F.nr;];

  // Now replace the top with the bottom and the bottom with the top.
  F[1:floor(F.nr/2);] = Bot;
  F[ceil(F.nr/2)+1:F.nr;] = Top;

  // Swap the right and left halves of the matrix.
  Left  = F[;1:floor(F.nc/2)];
  Right = F[;ceil(F.nc/2)+1:F.nc];

  // Do the swap.
  F[;1:floor(F.nc/2)] = Right;
  F[;ceil(F.nc/2)+1:F.nc] = Left;

  return F;
}

//-------------------------------------------------------------------//

//  Syntax:	tril ( A )
//		tril ( A , K )

//  Description:

//  tril(x) returns the lower triangular part of A.

//  tril(A,K) returns the elements on and below the K-th diagonal of
//  A.

//  K = 0: main diagonal
//  K > 0: above the main diag.
//  K < 0: below the main diag.

//  See Also: triu
//-------------------------------------------------------------------//

tril = function(x, k) 
{
  local(i, j, nr, nc, y);

  nr = size(x)[1]; nc = size(x)[2];
  if(abs(k) > nr) { error("invalid k value for tril()"); }
  y = zeros(nr, nc);

  for(i in max( [1,1-k] ):nr) {
    j = 1:min( [nc, i+k] );
    y[i;j] = x[i;j];
  }

  return y;
};

//
//KRYLOV    KRYLOV(A, x, j) is the Krylov matrix
//          [x, Ax, A^2x, ..., A^(j-1)x], where A is an n-by-n matrix and
//          x is an n-vector.
//          Defaults: x = ONES(n,1), j = n.
//          KRYLOV(n) is the same as KRYLOV(RAND(n)).

//  Reference: G.H. Golub and C.F. Van Loan, Matrix Computations, Johns Hopkins
//  University Press, Baltimore, Maryland, 1983, p. 224.

krylov = function(A, x, j)
{
  local(B, a, m, n);

  m = size(A)[1]; n = size(A)[2];

  if( n == 1 )  // Handle special case A = scalar.
  {
    n = A;
    a = rand(n,n);
  else
    a = A;
  }

  if( name(j) == "dummy" ) { j = n; }
  if( name(x) == "dummy" ) { x = ones(n,1); }

  B = ones(n,j);
  B[;1] = reshape(x, prod(size(x)), 1);
  for( i in 2:j )
  {
    B[;i] = a*B[;i-1];
  }

  return B;
}

//
//JORDAN  JORDAN(N, LAMBDA) is the N-by-N Jordan block with eigenvalue LAMBDA.
//        LAMBDA = 1 is the default.

jordan = function(n, lambda)
{
  if( name(lambda) == "dummy" ) { lambda = 1; }
  return ( lambda*eye(n,n) + diag(ones(n-1,1),1) );
}

//DIFF	Difference function.  If X is a vector [x(1) x(2) ... x(n)],
//	then DIFF(X) returns a vector of differences between adjacent
//	elements [x(2)-x(1)  x(3)-x(2) ... x(n)-x(n-1)].  If X is a
//	matrix, the differences are calculated down each column:
//	DIFF(X) = X(2:n,:) - X(1:n-1,:).
//	DIFF(X,n) is the n'th difference function.

diff = function ( X, k )
{
  local (i, m, n, x);

  if (name (k) == "dummy") { k = 1; }

  x = X;
  for (i in 1:k)
  {
    m = size(x)[1]; n = size(x)[2];
    if (m == 1)
    {
      x = x[2:n] - x[1:n-1];
    else
      x = x[2:m;] - x[1:m-1;];
    }
  }
  return x;
};

//
// poly() Characteristic polynomial.
// If X is an N by N matrix, poly(A) is a row vector with N+1 elements
// which are the coefficients of the characteristic polynomial,
// det(lambda*eye(A) - A) . 

// If X is a vector, poly(X) is a vector whose elements are the
// coefficients of the polynomial whose roots are the elements of X.
// For vectors, roots and poly are inverse functions of each other, up
// to ordering, scaling, and roundoff error.

poly = function(x) 
{
  local(c, e, ee, i, j, n);

  n = size(x);
  e = x;

  // If e is a matrix, get the eigenvalues
  if( !sum( n == 1 ) ) 
    {
      e = eig(e).val;
    }

  if( max( size(e) ) == 0 ) 
    {
      return 1;
    }

  // Strip infinities and throw away.
  for(i in 1:e.n) 
    {
      if(e[i] != (1/0)) {
	ee[i] = e[i];
      }
    }
  n = max( size(ee) );

  // Expand recursion formula
  c = [1, zeros(1,n)];

  for(j in 1:n) 
    {
      c[2:(j+1)] = c[2:(j+1)] - ee[j].*c[1:j];
    }

  // Force REAL if input X was REAL
  if(all (all (imag (x))) == 0) { c = real(c); }
  return c;
};

//-------------------------------------------------------------------//
//
// Syntax:	gamma ( A )

// Description:

// Computes the value of the gamma function. The input, A must be a
// row, or column vector. Allowable values of A are: A > 0.

// See Also: gammaln
//-------------------------------------------------------------------//

gamma = function( A )
{
  return exp( gammaln( A ) );
};

//-------------------------------------------------------------------//
//
// Syntax:	gammaln ( A )

// Description:

// Computes the value of the log-gamma function. The input, A must be
// a row, or column vector. Allowable values of A are: A > 0.

// Reference: Numerical Recipes in C, pp 168.
//-------------------------------------------------------------------//

gammaln = function( A )
{
  local(a, cof, j, ser, tmp);

  if( !all( A >= 0 ) )	// Test for correct input range
  { 
    return inf(); 
  }

  if( min(size(A)) != 1 )
  {
    error("input to gamma() must be a row, or column matrix");
  }

  cof = [76.18009173, -86.50532033, 24.01409822, ...
         -1.231739516, 0.120858003e-2, -0.536382e-5];

  a = A - 1;
  tmp = a + 5.5;
  tmp = tmp - (a + 0.5) .* log(tmp);
  ser = 1;
  for( j in 1:6 )
  {
    a = a + 1;
    ser = ser + cof[j]./a;
  }
  return ( -tmp + log(2.50662827465*ser) );
};

//-------------------------------------------------------------------//
//
// Syntax:	gammp ( A )

// Description:

// Computes the value of the incomplete gamma function, P(a,x).
// Currently the input, A, must be a row, or column matrix.

// Reference: Numerical Recipes in C, pp 172.
//-------------------------------------------------------------------//

gammp = function(A, X)
{
  local(gammcf, gammser, gln);

  if( any(X < 0) || any(A <= 0) ) {
    error("invalid arguments to gammp()");
  }

  if( any( X < (A + 1) ) )
  {
    return gser( A, X, gln );
  else
    return 1 - gcf( A, X, gln );
  }
};

//-------------------------------------------------------------------//
//
// Syntax:	gammq ( A )

// Description:

// Computes the value of the incomplete gamma function, 
// Q(a,x) = 1 - P(a,x). 
// Currently the input, A, must be a row, or column matrix.

// Reference: Numerical Recipes in C, pp 173.
//-------------------------------------------------------------------//

gammq = function(A, X)
{
  local(gammcf, gammser, gln);

  if( any(X < 0) || any(A <= 0) ) {
    error("invalid arguments to gammq()");
  }

  if( any( X < (A + 1) ) )
  {
    return 1 - gser( A, X, gln );
  else
    return gcf( A, X, gln );
  }
};

//-------------------------------------------------------------------//
//
// Syntax:	gser ( A )

// Description:

// Computes the value of the incomplete gamma function, evaluated by
// it's series representation.

// Reference: Numerical Recipes in C, pp 173.
//-------------------------------------------------------------------//

gser = function( A, X, GLN )
{
  local(ITMAX, ap, del, eps, n, sum);

  GLN = gammaln(A);
  if( any( X <= 0 ) )
  {
    if( any( X < 0 ) ) {
      error("X less than 0 in function gser()");
    }
    return 0;
  else
    ITMAX = 100; eps = epsilon();
    ap = A;
    del = sum = 1./A;
    for( n in 1:ITMAX )
    {
      ap = ap + 1;
      del = del .* X./ap;
      sum = sum + del;
      if( all( abs(del) < abs(sum).*eps ) )
      {
        return sum.*exp(-X + A.*log(X) - GLN);
      }
    }
    error("A too large, ITMAX too small in function gser()");
    return 0;
  }
};

//-------------------------------------------------------------------//
//
// Syntax:	gcf ( A )

// Description:

// Computes the value of the incomplete gamma function, evaluated by
// it's continued fraction representation.

// Reference: Numerical Recipes in C, pp 174.
//-------------------------------------------------------------------//

gcf = function( A, X, GLN )
{
  local(ITMAX, a0, a1, an, ana, anf, b0, b1, eps, fac, g, gold, n);

  ITMAX = 100;
  a0 = 1; b0 = 0; b1 = 1; fac = 1; gold = 0;
  eps = epsilon();
  GLN = gammaln(A);
  a1 = X;
  for( n in 1:ITMAX )
  {
    an = n;
    ana = an - A;
    a0 = (a1 + a0.*ana).*fac;
    b0 = (b1 + b0.*ana).*fac;
    anf = an.*fac;
    a1 = X.*a0 + anf.*a1;
    b1 = X.*b0 + anf.*b1;
    if( all(a1) )
    {
      fac = 1./a1;
      g = b1.*fac;
      if( abs((g - gold)/g) < eps )
      {
        return exp(-X + A.*log(X) - GLN).*g;
      }
    gold = g;
    }
  }
  error("A too large, ITMAX too small in function gcf()");
};

//FFT2	Two-dimensional Fast Fourier Transform.
//	FFT2(X) returns the two-dimensional Fourier transform of matrix X.
//	FFT2(X,MROWS,NCOLS) pads matrix X with zeros to size MROWS-by-NCOLS
//	before transforming.

// dependencies

rfile FFT

FFT2 = function(x_, mrows, ncols) {
  local(f);

  if (name(mrows) == "dummy") {
    f = conj(FFT( conj(FFT(x_)') )');
  else if (name(ncols) == "dummy") {
    f = conj(FFT( conj(FFT(x_,mrows)') )');
  else 
    f = conj(FFT( conj(FFT(x_,mrows)') ,ncols)');
  }}

  return f;
}

IFFT2 = function(x_, mrows, ncols) {
  local(f);

  if (name(mrows) == "dummy") {
    f = conj(IFFT( conj(IFFT(x_)') )');
  else if (name(ncols) == "dummy") {
    f = conj(IFFT( conj(IFFT(x_,mrows)') )');
  else   
    f = conj(IFFT( conj(IFFT(x_,mrows)') ,ncols)');
  }}

  return f;
}

//
//PASCAL  PASCAL(N) is the Pascal matrix of order N: a symmetric positive
//        definite matrix with integer entries, made up from Pascal's
//        triangle.  Its inverse has integer entries.
//        [Conjecture by NJH: the Pascal matrix is totally positive.]
//        PASCAL(N,1) is the lower triangular Cholesky factor (up to signs
//        of columns) of the Pascal matrix.   It is involutary (is its own
//        inverse).
//        PASCAL(N,2) is a transposed and permuted version of PASCAL(N,1)
//        which is a cube root of the identity.

//    J. Todd, Basic Numerical Mathematics, Vol. 2: Numerical Algebra,
//    Birkhauser, Basel, and Academic Press, New York, 1977, p. 172.

pascal = function(n, k)
{
  local(P);

  if( name(k) == "dummy" ) { k = 0; }

  P = diag( (-1).^[0:n-1] );
  P[;1] = ones(n,1);

  // Generate the Pascal Cholesky factor (up to signs).
  for( j in 2:n-1 )
  {
    for( i in j+1:n )
    {
      P[i;j] = P[i-1;j] - P[i-1;j-1];
    }
  }

  if( k == 0 ) 
  {
    P = P*P';
  else if( k == 2 ) {
    P = P';
    P = P[ n:1:-1 ;];
    for( i in 1:n-1 )
    {
      P[i;] = -P[i;];
      P[;i] = -P[;i];
    }
    if( n/2 == round(n/2) ) 
    {
      P = -P;
    }
  }}

  return P;
}

//
//  Write a function that evaluates a mathematical function.
//

humps = function(x) 
{
  return (1 ./ ((x-.3).^2 + .01) + 1 ./ ((x-.9).^2 + .04) - 6);
}

//
//  The following statements: 
//  Create a vector of the independent variable.

//  x = -1:2:.01;

//
//  Evaluate the function over the specified interval,
//  and write out the result in one statement.

//  write("humps-data"; [x; humps(x)]')

//
//  `hump(x)' evaluates the the function for x.
//  `[x; hump(x)]'' forms a matrix with the independent variable (x)
//  as the 1st column, and the evaluated function as the 2nd column.
//

conv = function( x , y )
{
  local( X , Y , tmp );

  X = fft( [ x , zeros(1, y.n-1) ] );
  Y = fft( [ y , zeros(1, x.n-1) ] );

  tmp = X.n .* ifft( X .* Y );
  if( type(x) == "real" && type(y) == "real") { tmp = real(tmp); }

  return tmp;
};

//-------------------------------------------------------------------//

//  Syntax:	detrend ( A )

//  Description:

//  Detrend removes a linear trend from a vector.

//  y = detrend (x) 

//  removes the best straight-line fit from the data in vector x and
//  returns it in vector y. Detrend is often used prior to fft().

//-------------------------------------------------------------------//

detrend = function ( x )
{
  local (a, m, n, y);

  m = size (x)[1]; n = size (x)[2];
  m = max ( [m, n] );
  y = reshape (x, prod (size (x)), 1);
  a = [ (1:m)'/m, ones(m,1) ];
  y = y - a*(a\y);
  if (n != 1)
  {
    y = conj (y');
  }
  return y;
};

//
// CHOP    CHOP(X, t) is the matrix obtained by rounding the elements of X
//         to t significant binary places.
//         Default is t=23, corresponding to IEEE single precision.
//

chop = function(x, t)
{
  local( c, e, m, n, p, y );
  if(name(t) == "dummy") { t = 23; }
  m = size(x)[1]; n = size(x)[2];

  // Use the representation:
  // x[i,j] = 2^e[i,j] * .d[1]d[2]...d[s] * sign(x[i,j])

  // On the next line `+(x==0)' avoids passing a zero argument to LOG, which
  // would cause a warning message to be generated.

  y = abs(x) + (x == 0);
  e = floor(log(y)./log(2) + 1);
  p = (2.*ones(m,n)).^(t-e);
  c = round(p.*x)./p;

  return c;
}

//
//  RLaB 4th Order Runge-Kutta Integrator
//  Fixed step size.
//  Ian Searle, 6/22/92

//
//  Inputs to rk4()
//  y:		State vector
//  dy:		State vector derivative
//  x:		Start time (t)
//  h:  	Time step (dt)
//  eval:	User-Function to evaluate state-derivative.
//		has arguments (time; y; dy)
//  Returns yout: The integration results
//

rk4 = function(y, dydx, x, h, eval) 
{
  local(i, xh, hh, h6, dym, dyt, yt, yout);

  hh = h*0.5;
  h6 = h/6;
  xh = x + hh;

  eval(x, y, dydx);      // 1st step
  yt = y + hh*dydx;

  eval(xh, yt, dyt);     // 2nd step
  yt = y + hh*dyt;

  eval(xh, yt, dym);     // 3rd step
  yt = y + h*dym;
  dym = dym + dyt;

  eval(x+h, yt, dyt);    // 4th step
  yout = y + h6*(dydx + dyt + 2.0*dym);

  return yout;
}

//
//  Driver for above integrator
//  This driver spares the caller the chore
//  of writing a for-loop
//

drk4 = function(y0, dy0, tzero, tfinal, dt, eval) 
{
  local(i, y, dy, yout, out);

  y = y0;
  dy = dy0;

  out = [tzero, y0];
  for(i in tzero:tfinal:dt) 
  {
    out = [out; i+dt, (y = rk4(y, dy, i, dt, eval))];
  }
  return out;
};

//-------------------------------------------------------------------//

//  Syntax:	save ( )
//		save ( FILE )

//  Description:

//  The save function writes the contents of all the workspace
//  variables to a file. The default file, if none is specified is
//  "SAVE".
//

//-------------------------------------------------------------------//

save = function ( FILE )
{
  local (i);

  if (name (FILE) == "dummy")
  {
    FILE = "SAVE";
  }
  for (i in members ($$))
  {
    if (class ($$.[i]) != "built-in" && class ($$.[i]) != "user-function")
    {
      write (FILE, $$.[i]);
    }
  }
  close (FILE);
};

//-------------------------------------------------------------------//
//
//  Syntax:	rank ( A )
//		rank ( A , tol )

//  Description:

//  Compute the rank of the matrix A. Rank returns the number of
//  values that are larger than max( size(x) ) * norm(x,"2") * eps. If
//  the user specifies tol, the the number of singular values larger
//  than tol is returned.

//-------------------------------------------------------------------//

rank = function(x, tol)
{
  local(s);
  s = svd(x);
  if( tol == 0 ) 
    { 
      tol = max(size(x)) * norm(x,"2") * epsilon();
    }
  return sum(s.sigma > tol);
};

// Boolean tests
isvector = function(M) {
  if (class(M) != "matrix") { return 0; }
  return ((M.nr*M.nc) == M.n);
}

issamesize = function(X,Y) {
  return ((X.nr == Y.nr) && (X.nc == Y.nc));
}

islist = function(X) {
  return (class(X) == "list");
}

isscalar = function(X) {
  return (class(X) == "scalar");
}

isstring = function(X) {
  return (class(X) == "string");
}

isinf2 = function(X) {
  return (abs(X) == inf());
}

isnan2 = function(X) {
  return (X!=X);
}

//-------------------------------------------------------------------//
//
//  Syntax:	diag ( A )
//		diag ( A , K )
//
//  Description:

//  If the 1st argument is a 1xN MATRIX construct a diagonal matrix
//  from the input . Optionally if K (SCALAR) is specified then create
//  a matrix with the vector as the Kth diagonal.

//  If the 1st argument is a MxN MATRIX, construct a 1xN MATRIX from
//  the diagonal elements of the input matrix. Optionally if K is
//  specified return the vector from the Kth diagonal of the input
//  matrix.
//
// 	K < 0 is below the main diagonal.
//  	K > 0 is above the main diagonal.
//
//-------------------------------------------------------------------//

diag = function(x, k) 
{
  local(i, m, n, v);

  if(min(size(x)) == 1)
  {
    // Form a matrix from a vector containing
    // the diagonal elements
    n = max( size(x) ) + abs(k);
    m = zeros(n, n);

    // Always construct for the k<0 case. If
    // k > 0 we will transpose when done.
    for(i in 1:x.n) {
      m[i+abs(k); i] = x[i];
    }

    if(k <= 0) { return m; }
    if(k > 0) { return m'; }
  }

  // Extract the diagonal elements
  // and create a vector.

   n = x.nr - abs(k);
   v = zeros(n,1);

  // Use 1 method of extracting diagonal, but
  // transpose input if necessary.
  if(k > 0) { 
    m = x'; 
  else
    m = x;
  }

  for(i in 1:n) {
    v[i] = m[i+abs(k); i];
  }
  return v;
};

//
// HOUSE   Householder matrix.
//         If [v, beta] = HOUSE(x) then H = EYE - beta*v*v' is a Householder
//         matrix such that Hx = -sign(x(1))*norm(x)*e_1.
//         NB: If x = 0 then v = 0, beta = 1 is returned.
//             x can be real or complex.
//             sign(x) := exp(i*arg(x)) ( = x./abs(x) when x ~= 0).

//         Theory: (textbook references Golub & Van Loan 1983, 38-43;
//                  Stewart 1973, 231-234, 262; Wilkinson 1965, 48-50).
//         Hx = y: (I - beta*v*v')x = -s*e_1.
//         Must have |s| = norm(x), v = x+s*e_1, and
//         x'y = x'Hx =(x'Hx)' real => arg(s) = arg(x(1)).
//         So take s = sign(x(1))*norm(x) (which avoids cancellation).
//         v'v = (x(1)+s)^2 + x(2)^2 + ... + x(n)^2
//             = 2*norm(x)*(norm(x) + |x(1)|).

house = function( x )
{
  local(beta, m, n, s, v);
  m = size(x)[1]; n = size(x)[2];
  if( n > 1 ) { error("Argument must be a column vector."); }

  s = norm(x, "2") * (sign(x[1]) + (x[1]==0));    // Modification for sign(0)=1.
  v = x;
  if( s == 0 ) { 
    beta = 1; 
    return beta;                                  // Quit if x is the zero vector.
  }
  v[1] = v[1] + s;
  beta = 1/(s'*v[1]);                             // NB the conjugated s.

  //  beta = 1/(abs(s)*(abs(s)+abs(x(1)))) would guarantee beta real.
  //  But beta as above can be non-real (due to rounding) only when x is complex.

  return << v = v ; beta = beta >>;
}

//
// Syntax:	compan ( P )

// Description:

// Compan(P), where P is an (n+1)-vector, is the n-by-n companion
// matrix whose first row is -P(2:n+1)/P(1). Special case: if P is a
// scalar then compan(P) is the P-by-P matrix compan(1:P+1).

//  References:
//  J.H. Wilkinson, The Algebraic Eigenvalue Problem, Oxford University Press,
//       1965, p. 12.
//  C. Kenney and A.J. Laub, Controllability and stability radii for companion
//       form systems, Math. Control Signals Systems, 1 (1988), pp. 239-256.
//       (Gives explicit formulas for the singular values of compan(P).)
//

compan = function( P )
{
  local(A, n, p);

  n = max(size(P));

  // Handle scalar P.
  if( n == 1 )
  {
    n = P+1;
    p = 1:n;
  else
    p = reshape( P, 1, prod(size(P)) );	// Ensure p is a row vector.
  }

  // Construct matrix of order n-1.
  if( n == 2 )
  {
    A = 1;
  else
    A = diag(ones(1,n-2),-1);
    A[1;] = -p[2:n]/p[1];
  }

  return A;
};

// flipud -- flip all the elements of a vector (or matrix) from top to bottom

flipud = function(A) {
  if (class(A) != "matrix") {
    error("flipud: Only matrix arguments supported");
  }

  // The obvious way to do this is painfully slow. Calling fliplr is
  // much faster.
  return fliplr(A')';
}

//
//SKEW  SKEW(A) is the skew-symmetric (Hermitian) part of A, (A-A')/2.
//      It is the nearest skew-symmetric (Hermitian) matrix to A in both the
//      2- and the Frobenius norms.
//

skew = function( A )
{
  return (A - A')./2;
}

//
// Calculate Fourier transform of a finite signal (SLOWLY)
//

sfft = function ( x )
{
  local(i, k, n, X);

  if(class(x) != "matrix") 
  {
    error("input to sfft must be a matrix");
  }

  X = zeros( size(x) );

  for( k in 1:x.n )
  {
    for( n in 1:x.n )
    {
      X[k] = X[k] + x[n]*exp( (-1i*2*pi*(k-1)*(n-1))/x.n );
    }
  }

  return X;
}

//
// BANDRED  B = BANDRED(A, KL, KU) is a matrix orthogonally equivalent to A
//          with lower bandwidth KL and upper bandwidth KU
//          (i.e. B(i,j) = 0 if i>j+KL or j>i+KU).
//          The reduction is performed using Householder transformations.
//          If KU is omitted it defaults to KL.

//          This routine is called by RANDSVD.
//          This is a `standard' reduction.  Cf. reduction to bidiagonal form
//          prior to computing the SVD.  This code is a little wasteful in that
//          it computes certain elements which are immediately set to zero!

rfile house

bandred = function(A, kl, ku)
{
  local(a, beta, flip, j, ltmp, m, n, temp, v, z);

  if( name(ku) == "dummy" ) { ku = kl; }

  if( kl == 0 && ku == 0 ) {
    error("You've asked for a diagonal matrix. In that case use the SVD!");
  }

  // Check for special case where order of left/right transformations matters.
  // Easiest approach is to work on the transpose, flipping back at the end.

  a = A;
  flip = 0;
  if( ku == 0 )
  {
    a = a';
    temp = kl; 
    kl = ku;
    ku = temp; 
    flip = 1;
  }

  m = size(a)[1]; n = size(a)[2];

  if( (z=min( [min([m,n]),max([m-kl-1,n-ku-1]) ] )) >= 1 )
  {
    for( j in 1:z )
    {
      if( j+kl+1 <= m )
      {
         ltmp = house( a[j+kl:m; j] );
         beta = ltmp.beta; v = ltmp.v;
         temp = a[j+kl:m; j:n];
         a[j+kl:m; j:n] = temp - beta*v*(v'*temp);
         a[j+kl+1:m; j] = zeros(m-j-kl,1);
      }

      if( j+ku+1 <= n )
      {
         ltmp = house( a[j; j+ku:n]' );
         beta = ltmp.beta; v = ltmp.v;
         temp = a[j:m; j+ku:n];
         a[j:m; j+ku:n] = temp - beta*(temp*v)*v';
         a[j; j+ku+1:n] = zeros(1,n-j-ku);
      }
    }
  }

  if( flip ) {
   a = a';
  }
  return a;
}

//-------------------------------------------------------------------//
//  Syntax:	funm ( A , fun )

//  Description:

//  Funm evaluates matrix functions. The 1st argument, `A' is the
//  matrix used in the evaluation, and the 2nd argument, `fun' is the
//  name of the scalar function that will be used.

//  For example:

//  next = funm ( A , exp );

//  The above will calculate the matrix exponential.

//-------------------------------------------------------------------//

funm = function ( A, fun )
{
  local (e, tmp);

  if (size (A)[1] != size (A)[2])
  {
    error ("Matrix argument to funm() must be square");
  }
  e = eig (A);
  tmp = diag (fun (e.val));
  return e.vec*tmp/e.vec;
};

//
// Compute the rank of the matrix X. Rank returns the number of
// values that are larger than max( size(x) ) * norm(x,"2") * eps
// If the user specifies TOL, the the number of singular values
// larger than TOL is returned.
//

rank = function(x,tol)
{
  s = svd(x);
  if( tol == 0 ) 
    { 
      tol = max(size(x)) * s.sigma[1] * epsilon();
    }
  return sum(s.sigma > tol);
}

// median3 -- compute the 3-point median filter. This function performs three
//            point median filtering along a vector or along the columns of
//            a matrix.

median3 = function(M) {
  local(M1,M2,M3,M4,Mout);

  if (class(M) != "matrix") { error("median3: Input must be a matrix"); }

  if (isvector(M)) {
    if (length(M) < 3) { return M; }

    M1 = M[2:length(M)-1];
    M2 = M[1:length(M)-2];
    M3 = M[3:length(M)];
    M4 = M1 - (0.5)*M2 - (0.5)*M3;
    Mout = M;
    Mout[2:length(M)-1] = (M2+M3+abs(M4+abs(M2-M3)/2)-abs(M4-abs(M2-M3)/2))/2;
    return Mout;
  }

  if (M.nr < 3) { return M; }

  M1 = M[2:M.nr-1;];
  M2 = M[1:M.nr-2;];
  M3 = M[3:M.nr;];

  M4 = M1 - (0.5)*M2 - (0.5)*M3;

  Mout = M;
  Mout[2:M.nr-1;] = (M2+M3+abs(M4+abs(M2-M3)/2)-abs(M4-abs(M2-M3)/2))/2;
  return Mout;
}

// fliplr -- flip all the elements of a vector (or matrix) from left to right

fliplr = function(A) {
  local(B);
  if (class(A) != "matrix") {
    error("fliplr: Only matrix arguments supported");
  }

  B[;1:A.nc] = A[;A.nc:1:-1];
  return B;
}

//-------------------------------------------------------------------//
//
//  Syntax:	mean ( A )

//  Description:

//  Calculate the mean value. If the input is a 1xN, then compute the
//  mean value of all the elements. 

//  If the input is a MxN matrix the compute a row matrix of the mean
//  value of each column of the input. 
//
//-------------------------------------------------------------------//

mean = function(x)
{
  local(m);

  m = size (x)[1];
  if( m == 1 ) 
  { 
    m = size (x)[2];
  }

  return sum( x ) / m;
};

//
//  Integrate the Van def Pol equation
//

vdpol = function ( t, x ) {
  local(xdot);

  xdot[1;1] = x[1] * (1 - x[2]^2) - x[2];
  xdot[2;1] = x[1];
  return xdot;
}

// system( "/usr/ucb/ps -aux | grep rlab" );
t0 = 0;
tf = 20;
x0 = [0; 0.25];
rfile ode78
tic();
out = ode78( vdpol, t0, tf, x0);
printf(" Elapsed integrtion time: %i\n", toc() );
plot( out );

//  HANKEL(C) is a square Hankel matrix whose first column is C and
//  whose elements are zero below the first anti-diagonal.
//  HANKEL(C,R) is a Hankel matrix whose first column is C and whose
//  last row is R.
//  Hankel matrices are symmetric, constant across the anti-diagonals,
//  and have elements H[i;j] = R[i+j-1].  See also TOEPLITZ.

hankel = function(c_,r_) {
  local(c,r,nc,h,j,nr);

  if (class(c_) != "matrix") { error("hankel: Inputs must be vectors"); }
  if (!isvector(c_)) { error("hankel: Inputs must be vectors"); }

  c = c_[:];
  nc = length(c);

  if (name(r_) == "dummy") {
    h = zeros(nc,nc);
    for (j in 1:nc) {
      h[1:nc-j+1;j] = c[j:nc];
    }
  else
    if (class(r_) != "matrix") { error("hankel: Inputs must be vectors"); }
    if (!isvector(r_)) { error("hankel: Inputs must be vectors"); }
    if (length(c_) != length(r_)) {
      error("hankel: Inputs must have the same length");
    }
    r = r_[:];
    nr = length(r);
    h = zeros(nc,nr);
    if (c[nc] != r[1]) {
      error("hankel: First element of row must match last element of column");
    }
    for (j in 1:nc-1) {
      h[;j] = [c[j:nc-1]; r[1:j]];
    }
    h[;nc] = r;
  }
  return h;
}

// FFT -- perform MATLAB-like FFT.
//
//        This routine uses the built-in fft function to calculate the
//        DFT of a matrix. The FFT is performed on each column separately.
//        F = FFT(X) returns the un-normalized FFT (unlike the built-in function
//        which divides by N). FFT(X,N) pads or truncates the column vectors
//        to length N.

FFT = function(M_,dim) {
  local(F,col,M);

  if (class(M_) != "matrix") { error("FFT: Argument must be a matrix"); }

  M = M_;
  if (name(dim) != "dummy") {
    if (class(dim) != "scalar") { error("FFT: Dimension must be a scalar"); }
    if (dim < M.nr) {
      M = M[1:dim;];
    else if (dim > M.nr) {
      M = [M; zeros(dim-M.nr,M.nc)];
    }}
  }
      
  F = fft(M);
  return M.nr*F;
}

IFFT = function(M_,dim) {
  local(F,col,M);

  if (class(M_) != "matrix") { error("IFFT: Argument must be a matrix"); }

  M = M_;
  if (name(dim) != "dummy") {
    if (class(dim) != "scalar") { error("IFFT: Dimension must be a scalar"); }
    if (dim < M.nr) {
      M = M[1:dim;];
    else if (dim > M.nr) {
      M = [M; zeros(dim-M.nr,M.nc)];
    }}
  }

  F = ifft(M);
  return F/M.nr;
}

//	TOEPLITZ(C,R) is a non-symmetric Toeplitz matrix having C as its
//	first column and R as its first row.   TOEPLITZ(C) is a symmetric
//	(or Hermitian) Toeplitz matrix.  See also HANKEL.

// dependencies

rfile is
rfile fliplr
rfile flipud
rfile hankel

toeplitz = function(c_,r_) {
  local(c,r,nc,h,j,nr);

  if (class(c_) != "matrix") { error("toeplitz: Inputs must be vectors"); }
  if (!isvector(c_)) { error("toeplitz: Inputs must be vectors"); }

  c = c_[:];
  nc = length(c);

  if (name(r_) == "dummy") {
    r = c;
  else
    if (class(r_) != "matrix") { error("toeplitz: Inputs must be vectors"); }
    if (!isvector(r_)) { error("toeplitz: Inputs must be vectors"); }
    if (length(c_) != length(r_)) {
      error("toeplitz: Inputs must have the same length");
    }
    r = r_[:];
    if (c[1] != r[1]) {
      error("toeplitz: First element of row must match first element of column");
    }
  }

  r = flipud(r);
  h = zeros(nc,nc);
  h[;1] = c;
  for (j in 2:nc) {
    h[;j] = [r[nc-j+1:nc-1]; c[1:nc-j+1]];
  }
  return h;
}

//
// An example that finds all primes less than limit
//

primes = function (limit) {
  local(prime, cnt, i, j, k);

  i = 1; j = 0; cnt = 0;
  for(k in 2:limit) 
  {
    j = 2;
    while(mod(k,j) != 0) {
      j++;
    }
    if(j == k) {            // Found prime
      cnt++;
      prime[1;i] = k;
      i++;
    }
  }
  return prime;
}

//
// Randomly generate passwordds
// Ian Searle (11/6/91)
//

alpha = ["a", "b", "c", "d", "e", "f", "g", "h", "i", ...
         "j", "k", "l", "m", "n", "o", "p", "q", "r", ...
         "s", "t", "u", "v", "w", "x", "y", "z" ];

//
// Global set-up
//

srand( "clock" );

pwd = function()
{
  local(i, PWD, tmp);

  tmp = "";
  rand("uniform", 1, 26);
  for(i in 1:6) {
    PWD[i]   = alpha[ irand() ];
  }

  rand("uniform", 0, 9);
  
  sprintf(tmp, "%i", irand());
  PWD[7] = tmp;
  sprintf(tmp, "%i", irand());
  PWD[8] = tmp;

  return PWD;
}

//
// Return an integer random number between 1 and 26
//

irand = function()
{
  return int( rand() );
}

//
// From MATRIX Computations, G.H. Golub, C.F. Van Loan
//

//
// Create a LIST to hold the Householder related functions.
// These functions have only been used with REAL inputs.
//

house = <<>>;

//
// house.v(): Given an N-vector X, generate an n-vector V
// with V[1] = 1, such that (eye(n,n) - 2*(V*V')/(V'*V))*X
// is zero in all but the 1st component.
//

  house.v = function(x)
  {
    local(b, n, u, v);
  
    v = x;
    n = max( size(x) );
    u = norm(x, "2");
    if(u != 0)
      {
	b = x[1] + sign(x[1])*u;
	if(n > 1) {
	  v[2:n] = v[2:n]/b;
	}
      }
    v[1] = 1;
    return v;
  };

//
// house.row(): Given an MxN matrix A and a non-zero M-vector V
// with V[1] = 1, the following algorithm overwrites A with 
// P*A, where P = eye(m,m) - 2*(V*V')/(V'*V)
//

  house.row = function(A, v)
  {
    local(a, b, w);
    
    a = A;
    b = -2/(v'*v);
    w = b*A'*v;
    a = A + v*w';
    return a;
  };

//
// house.col(): Given an MxN matrix A, and an N-vector V, 
// with V[1] = 1, the following algorithm overwrites A with A*P
// where P = eye(N,N) - 2*(V*V')/(V'*V)
//
 
  house.col = function(A,v)
  {
    local(a, v, b, w);

    b = -2/(v'*v);
    w = b*A*v;
    a = A + w*v';

    return a;
  };

//
// Given A, with M >= N, the follwoing function finds Householder
// matrices H1,...Hn, such that if Q = H1*...Hn, then Q'*A = R is
// upper triangular.
//

house.qr = function(A)
  {
    local(a,j,n,m,v);

    a = A;
    m = size(A)[1]; n = size(A)[2];
    v = zeros(m,1);

    for(j in 1:n)
      {
        v[j:m] = house.v( a[j:m;j] );
        a[j:m;j:n] = house.row( a[j:m;j:n], v[j:m] );
	if(j < m) {
	a[ (j+1):m;j ] = v[(j+1):m];
        }
      }
    return a;
  };

//
//  Generate P matrix
//

P = function(V)
{
  local( m );

  m = max( size(V) );
  return [ eye(m,m) - 2*(V*V')./(V'*V) ];
}

//
// HILB   HILB(N) is the N-by-N Hilbert matrix with elements 1/(i+j-1),
//        which is a famous example of a badly conditioned matrix.
//        See INVHILB (standard MATLAB routine) for the exact inverse, which
//        has integer entries.
//        HILB(N) is symmetric positive definite, totally positive, and a
//        Hankel matrix.

//        This routine is shorter and faster than the one supplied with MATLAB.

//        References: D.E. Knuth, The Art of Computer Programming,
//        Volume 1, Fundamental Algorithms, Second Edition, Addison-Wesley,
//        Reading, Massachusetts, 1973, p. 37.
//        M.-D. Choi, Tricks or treats with the Hilbert matrix, Amer. Math.
//        Monthly, 90 (1983), pp. 301-312.

// Dependencies

rfile cauchy

mhilb = function( n )
{
  local( H );

  if( n == 1 )
  {
    H = 1;
  else
    H = cauchy( (1:n) - .5);
  }

  return H;
}

//-------------------------------------------------------------------//

//  RLaB plot function. Maybe someday plotting will be built-in, but
//  for now we will do it via this user-function and some global
//  variables. This user-function is only an example. If it does not
//  suit your needs, you should modify it so that it does.

//  Syntax: plot ( x )

//  Description: 

//  plot() takes a single argument which can either be a MATRIX, or a
//  STRING. If x is a MATRIX then the columns are plotted versus the
//  1st column. If x is a STRING then the string is passed directly to
//  GNUPLOT with a newline added to the end.

//  This function could stand some improvement. The ability to plot
//  3-d data (3-columns), ability to plot complex data, etc... 

//-------------------------------------------------------------------//

//
// pinfo is a global list used to hold data that we need from plot()
// to plot(). 
//

pinfo = <<>>;			// Create the global table
pinfo.init = 0;			// Used in plot() as an init flag
pinfo.tmpf = "|rm -f `cat`";	// Used to clean up tmp files
pinfo.files = "";		// A list of tmp files to plot from
pinfo.gnuplot = "|gnuplot";	// The STRING used to write to GNUPLOT
pinfo.term = "set term X11\n";	// The GNUPLOT terminal type

plot = function ( data ) 
{
  local(ans, filenm, i, nplot, plot_cmd, tmps);

  // Initialize

  plot_cmd = "plot"; tmps = "";

  if(!pinfo.init) 
  {
    fprintf(pinfo.gnuplot, "%s", pinfo.term);
    fprintf(pinfo.gnuplot, "set data style lines\n");
    fprintf(pinfo.gnuplot, "set grid\n");
    pinfo.init = 1;
  }

  if(class(data) == "string") 
  {
    fprintf(pinfo.gnuplot, "%s\n", data);

  else

    if(class(data) != "matrix") 
    {
      error("must supply a MATRIX to plot");
    }

    // Close any previously opened files.
    close(pinfo.files);

    //
    // Loop on the number of columns in [data], writing pairs of
    // columns to tmp files. At the same time create the GNUPLOT
    // command to plot the data in each of the files.
    //

    nplot = max ( [1, data.nc - 1] );
    if (nplot > data.nr)
    {
      printf (" Plot %i columns, are you sure (y/n) ? ", data.nc);
      ans = getline ("stdin");
      if (ans.[1] != "y")
      {
        return 0;
      }
    }

    for(i in 1:nplot)
    { 
      // tmp-files
      filenm.[i] = "";
      sprintf(filenm.[i], "rlab-tmpf-%i", i);

      if(nplot == 1) 
      {
        write (filenm.[i], real (data) );
      else
        write (filenm.[i], real (data[;1, i+1]));
      }
      close(filenm.[i]);

      // plot-command
      if(i == 1) 
      {
        sprintf(tmps, " '%s' title '%s-%i'", filenm.[i], name(data), i+1);
      else
        sprintf(tmps, ", '%s' title '%s-%i'", filenm.[i], name(data), i+1);
      }

      plot_cmd = plot_cmd + tmps;
      pinfo.files = pinfo.files + " " + filenm.[i];
    }

    //
    // Send the plot command to GNUPLOT
    //
  
    fprintf (pinfo.gnuplot, "%s\n", plot_cmd);
  
    //
    // Generate the shell command which will delete the tmp
    // files when the command is closed (via pclose()).
    //
  
    fprintf(pinfo.tmpf, pinfo.files);
  }
};

//-------------------------------------------------------------------//

//  Syntax:	ones ( M , N )
//		ones ( A )

//  Description:

//  Create a matrix of ones. If the input is two scalars,
//  then create a matrix of 1s with dimensions NxM. 

//  If the input is a 2 element matrix, then create a matrix with row
//  and column dimensions equal to A[1] and A[2] respectively. This is
//  useful when used in conjunction with size():

//	ones( size( X ) )

//  will return a matrix of ones the same size as X.

//-------------------------------------------------------------------//


ones = function( m, n ) 
{
  local(i, N);

  if (name (n) == "dummy")
  {
    if(m.n != 2) { error("only 2-el MATRIX allowed as ones() arg"); }
    return (zeros (m[1], m[2]) + 1);
  else
    if (type (m) == "string" || type (n) == "string") 
    {
      error ("eye(), string arguments not allowed");
    }
    if (max (size (m)) == 1 && max (size (n)) == 1)
    {
      return (zeros (m[1], n[1]) + 1);
    else
      error ("matrix arguments to eye() must be 1x1");
    }
  }
};

//
// CAUCHY  C = CAUCHY(X,Y), where X,Y are N-vectors, is the N-by-N matrix
//         with C(i,j) = 1/(X(i)+Y(j)).   By default, Y = X.
//         Special case: if X is a scalar CAUCHY(X) is the same as CAUCHY(1:X).
//         Explicit formulas are known for DET(C) (which is nonzero if X and Y
//         both have distinct elements) and the elements of INV(C).

//         Reference: D.E. Knuth, The Art of Computer Programming, Volume 1,
//         Fundamental Algorithms, Second Edition, Addison-Wesley, Reading,
//         Massachusetts, 1973, p. 36.

cauchy = function(X, Y)
{
  local(C, n, x, y);

  x = X; y = Y;
  n = max(size(x));

  //  Handle scalar x.
  if( n == 1 )
  {
    n = x;
    x = 1:n;
  }

  if( name(Y) == "dummy" ) { y = x; }

  // Ensure x and y are column vectors.
  x = reshape(x, prod(size(x)), 1);
  y = reshape(y, prod(size(y)), 1);
  if( any(size(x) != size(y))) {
    error("Parameter vectors must be of same dimension.")
  }

  C = x*ones(1,n) + ones(n,1)*conj(y');
  C = ones(n,n) ./ C;
  return C;
}

//
// RIEMANN    A = RIEMANN(N) is a N-by-N matrix associated with the
//            Riemann hypothesis, which is true if and only if
//            DET(A) = O( N! N^(-1/2+epsilon) ) for every epsilon>0
//                                              ('!' denotes factorial).
//            A = B(2:N+1, 2:N+1), where B(i,j) = i-1 if i divides j and
//            -1 otherwise.
//            Properties include, with M = N+1:
//               Each eigenvalue E(i) satisfies ABS(E(i)) <= M - 1/M.
//               i <= E(i) <= i+1 with at most M-SQRT(M) exceptions.
//               All integers in the interval (M/3, M/2] are eigenvalues.

//            Reference:  F. Roesler, Riemann's hypothesis as an
//            eigenvalue problem, Linear Algebra and Appl., 81 (1986),
//            pp. 153-198.

riemann = function( N )
{
  local(i, j, n);
  n = N;
  n = n+1;
  i = (2:n)' * ones(1,n-1);
  j = i';
  return (i .* (!mod(j,i)) - ones(n-1,n-1));
}

//
//  Syntax: qrs ( A )

//  Description:

//  Qrs stands for QRSimple. This is a simple QR decomposition that
//  employs Householder transforms to generate the upper-triangular R.
//  Q, as returned, is the product of the separate Houselholder
//  transforms.

//  This function is VERY INEFFICIENT. All of the intermediate matrix
//  products are saved. For educational purposes only.
//

//  Dependencies

rfile house

qrs = function( A )
{
  local(a, i, j, l, m, n, p, q, v);

  m = A.nr; n = A.nc;
  if( m >= n ) {
    l = n;
  else
    l = n - m;
  }

  // 1st transformation
  v.[1] = house.v( A[;1] );
  p.[1] = P ( v.[1] );
  a.[1] = p.[1]*A;

  q = p.[1];

  for ( i in 2:l )
  {
    v.[i] = house.v( a.[i-1][i:a.[i-1].nr;i] );
    p.[i] = P ( v.[i] );

    p.[i] = [eye(i-1,i-1),zeros(i-1,p.[i].nc);zeros(p.[i].nr,i-1),p.[i]];
    a.[i] = p.[i]*a.[i-1];

    q = p.[i]*q;
  }

  return << q = q ; r = a.[i] >>;
}

//-------------------------------------------------------------------//

//  Syntax:	triu ( A )
//		triu ( A , K )

//  Description:

//  triu(x) returns the upper triangular part of A.

//  tril(x; k) returns the elements on and above the k-th diagonal of
//  A. 

//  K = 0: main diagonal
//  K > 0: above the main diag.
//  K < 0: below the main diag.

//  See Also: tril
//-------------------------------------------------------------------//

triu = function(x, k) 
{
  local(i, j, nr, nc, y);

  nr = size(x)[1]; nc = size(x)[2];
  if(abs(k) > nr) { error("invalid k value for triu()"); }
  y = zeros(nr, nc);

  for(j in max( [1,1+k] ):nc) {
    i = 1:min( [nr, j-k] );
    y[i;j] = x[i;j];
  }

  return y;
};

// Numerical evaluation of integrals (quadrature).
// Q = quad(f,a,b) approximates the integral of f(x) from a to b to
// within a relative error of 1e-3. `f' is the name of the function
// that evaluates f(x). Function f must return a vector of output
// values if given a vector of input values. 
// q = quad(F,a,b,tol) integrates to a relative error of tol. 
// An error occurrs if an excessive recursion level is reached,
// indicating a possibly singular integral.  
// q = quad(F,a,b,tol) integrates to a relative error of tol
// quad() uses an adaptive recursive Simpson's rule.

quad = function(func, a, b, tol) 
{
  local(c, cnt, fa, fb, fc, lev, q, x, y);

  if(tol == 0) { tol = 1.e-3; }

  c = (a + b)/2;

  // Top level initialization

  x = [ a, b, c, (a:b:(b-a)/10) ];
  y = func(x);  // Evaluate caller's function
  fa = y[1];    // func() evaluated at a, b, c
  fb = y[2];
  fc = y[3];
  lev = 1;

  // Adaptive, recursive Simpson's quadrature
  q = quadstp(func, a, b, tol, lev, fa, fc, fb, 0);
  cnt = q.cnt + 3;

  return << q=q.Q; cnt=cnt >>;
};

// quadstp() Recursive function used by quad(F,a,b,tol).

// q = quadstp(F,a,b,tol,lev,fa,fc,fb,Q0) tries to approximate
// the integral of f(x) from a to b to within a relative error of tol.
// F is the name of the function that evaluated f(x). The remaining
// arguments are generated by quad or by the recursion.  lev is the
// recursion level. 
// fa = f(a). fc = f((a+b)/2). fb = f(b).
// Q0 is an approximate value of the integral.

quadstp = function(func, a, b, tol, lev, fa, fc, fb, Q0) 
{
  local(c, cnt, f, h, L1, L2, x, LEVMAX, Q);

  LEVMAX = 10;
  if(lev > LEVMAX) {
    error("Recursion level limit reached in quad. Singularity likely");
  else
    h = b - a;
    c = (a + b)/2;
    x = [ (a+h/4), (b-h/4) ];
    f = func(x);
    
    cnt = 2;
    
    // Simpson's rule for half intervals.
    L1.Q = h*(fa + 4*f[1] + fc)/12;
    L2.Q = h*(fc + 4*f[2] + fb)/12;
    Q = L1.Q + L2.Q;
   
    // Recursively refine approximations.
    if(abs(Q - Q0) > tol*abs(Q)) {
      L1 = quadstp(func, a, c, tol/2, lev+1, fa, f[1], fc, L1.Q);
      L2 = quadstp(func, c, b, tol/2, lev+1, fc, f[2], fb, L2.Q);
      Q = L1.Q + L2.Q;
      cnt = cnt + L1.cnt + L2.cnt;
    }
  }
  return << Q=Q; cnt=cnt >>;
};

//-------------------------------------------------------------------//
//	ode23.r
// 	Integrate a system of ordinary differential equations using
// 	2nd and 3rd order Runge-Kutta formulas.
// 	ode23(ufun; t0; tf; y0) integrates the system
// 	of ordinary differential equations described by the 
//	user-function ufun() over the interval t0 to tf and using 
//	initial	conditions y0.
// 	ode23(ufun; t0; tf; y0; tol; 1) uses tolerance tol
// 	and displays status while the integration proceeds.
// 

ode23 = function(Ufun, t0, tfinal, y0, tol, trace) 
{
  local(delta, h, hmax, hmin, pow, s1, s2, s3, t, tau, tout, y, yout);

  //  Initialization
  pow = 1/3;

  if(tol == 0) { tol = 0.001; }

  //  Initialization
  t = t0;
  hmax = (tfinal - t)/5;
  hmin = (tfinal - t)/20000;
  h = (tfinal - t)/100;
  y = y0[:];
  tout = t;
  yout = y.';
  tau = tol * max([norm(y, "i"), 1]);

  if(trace) {
    [t, h, y[:]']
  }

  //  The main loop
  while((t < tfinal) && (h >= hmin)) {
    if(t + h > tfinal) { h = tfinal - t; }

    // Compute the slopes
    s1 = Ufun(t, y);
    s2 = Ufun(t+h, y+h*s1);
    s3 = Ufun(t+h/2, y+h*(s1+s2)/4);

    //Estimate the error and the acceptable error
    delta = norm( h*(s1 - 2*s3 + s2)/3, "i" );
    tau = tol*max( [norm(y,"i"), 1.0] );

    // Update the solution only if the error is acceptable
    if(delta <= tau) 
    {
      t = t + h;
      y = y + h*(s1 + 4*s3 + s2)/6;
      tout = [tout; t];
      yout = [yout; y.'];
    }

    if(trace) { [t, h, y[:]']? }

    //Update the step size
    if(delta != 0.0) {
      h = min( [ hmax, 0.9*h*(tau/delta)^pow ] );
    }
  }

  if(t < tfinal) {
    printf("SINGULARITY LIKELY, t = %f, h = %f\n", t, h);
    error("Error in ode23()");
  }

  return [tout, yout];
};

//-------------------------------------------------------------------//
//
//  Syntax:	pinv ( A )
//		pinv ( A , tol )

//  Description:

//  Pseudoinverse. X = PINV(A) produces a matrix X of the same
//  dimensions as A' so that A*X*A = A , X*A*X = X and AX and XA are
//  Hermitian. The computation is based on svd(A) and any singular
//  values less than a tolerance are treated as zero. The default
//  tolerance is max(size(A)) * norm(A,"2") * eps.  This tolerance may be
//  overridden with X = pinv(A,tol).  

//  See Also: rank

//-------------------------------------------------------------------//

pinv = function(A, tol)
{
  local(eps, r, S, s, X);

  // Pseudo-inverse, ignore singular values <= tol.
  // Default tol = max(size(A)) * s(1) * eps.

  s = svd(A);
  if(tol = 0) { tol = max(size(A)) * norm(A,"2") * epsilon(); }
 
  r = norm( (s.sigma > tol)' );
  if(r == 0) { 
    X = zeros( A' ); 
  else
    S = diag(ones(r,1) ./ s.sigma'[1:r]);
    X = s.vt'[;1:r] * S * s.u[;1:r]';
  }

  return X;
};

//
// roots(): Find polynomial roots. 

// roots(V) computes the roots of the polynomial whose coefficients
// are the elements of the vector V. If V has N+1 components, the
// polynomial is: V(1)*X^N + ... + V(N)*X + V(N+1)
//

roots = function(c) 
{
  local(a, inz, n, nnz, r, v);

  // Make a copy
  v = c;
  n = size(v);

  if( !sum( n <= 1 ) ) {
    error("Must be a vector");
  }

  n = max( n );

  // Strip leading zeros and throw away.  Strip trailing zeros,
  // but remember them as roots at zero.

  inz = find( abs(v) );
  nnz = max( size(inz) );

  if(nnz != 0) 
    {
      v = v[ inz[1]:inz[nnz] ];
      r = zeros( 1, n - inz[nnz] );
    }

  // Polynomial roots via a companion matrix
  n = max( size(v) );
  a = diag( [ones(1,n-2)], -1);
  if(n > 1) {
    a[1;] = -v[2:n] ./ v[1];
  }

  return conj([r, eig(a).val])';
};

//
// AUGMENT  AUGMENT(A) is the square matrix [EYE(m) A; A' ZEROS(n)] of dimension
//          m+n, where A is m-by-n.  It is the symmetric and indefinite
//          coefficient matrix of the augmented system associated with a least
//          squares problem minimize NORM(A*x-b).
//
//          Special case: if A is a scalar, n say, then AUGMENT(A) is the same
//                        as AUGMENT(RAND(p,q)) where n = p+q and p = ROUND(n/2),
//                        that is, a random augmented matrix of dimension n is
//                        produced.

//    Reference:  G.H. Golub and C.F. Van Loan, Matrix Computations, Second
//    Edition, Johns Hopkins University Press, Baltimore, Maryland, 1989, p. 253.


augment = function( A )
{
  local( a , m , n , p, q );

  a = A;
  m = size(A)[1]; n = size(A)[2];

  if( max( [m,n] ) == 1 )
  {
    n = a;
    p = round(n/2);
    q = n - p;
    a = rand(p,q);
    m = p; n = q;
  }

  return [ eye(m,m) , a ; a' , zeros(n,n) ];
}
